//========================================================================================
//
//	File:				Frame.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FRAME_H
#define FRAME_H

// ----- Framework Includes -----

#ifndef FWFRAME_H
#include "FWFrame.h"
#endif

#ifndef FWDRGDRP_H
#include "FWDrgDrp.h"
#endif

// ----- Foundation Layer -----

#ifndef FWRECEVR_H
#include "FWRecevr.h"
#endif

// ----- shapes -----

//========================================================================================
// Forward Declarations
//========================================================================================

class FW_CMenuEvent;

class CFormPart;
class CFormContent;

class CRectView;
class CPictView;
class FW_CEditView;
class FW_CEditView;
class FW_CEditView;
class FW_CEditView;
class FW_CEditView;
class FW_CButton;
class FW_CRadioCluster;
class FW_CGroupBox;
class FW_CButton;
class FW_CListBox;
class FW_CButton;
class FW_CButton;
class FW_CPopupMenu;
class FW_CPopupMenu;
class FW_CRadioCluster;
class FW_CGroupBox;
class FW_CButton;
class FW_CRadioCluster;
class FW_CGroupBox;
class FW_CButton;
class FW_CButton;
class FW_CScrollBar;
class FW_CScrollBar;

//========================================================================================
// CFormFrame
//========================================================================================

class CFormFrame : public FW_CFrame, public FW_MReceiver, public FW_MDraggableFrame, public FW_MDroppableFrame
{
//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
  public:
  	FW_DECLARE_CLASS
	FW_DECLARE_AUTO(CFormFrame)

	CFormFrame(Environment* ev, 
				ODFrame* odFrame, 
				FW_CPresentation* presentation, 
				CFormContent* content);

	virtual ~CFormFrame();

//----------------------------------------------------------------------------------------
//	Inherited API
//
	virtual ODDragResult CanAcceptDrop(Environment* ev, ODDragItemIterator* dragInfo);

	virtual FW_Boolean	DoAdjustMenus(Environment* ev,
									  FW_CMenuBar* menuBar, 
									  FW_Boolean hasMenuFocus,
									  FW_Boolean isRoot);

	virtual FW_Boolean	DoMenu(Environment* ev,
							   const FW_CMenuEvent& theMenuEvent);

	virtual FW_Boolean	DoMouseDown(Environment* ev, const FW_CMouseEvent& theMouseEvent);

	virtual void		Draw(Environment *ev, 
							 ODFacet* odFacet, 
							 ODShape* invalidShape);

	virtual void		FrameShapeChanged(Environment* ev);
	virtual void		CreateSubViews(Environment* ev);

	virtual FW_CDragCommand* NewDragCommand(Environment *ev,
											FW_CFrame* theFrame,
											const FW_CMouseEvent& theMouseEvent);
	virtual FW_CDropCommand* NewDropCommand(Environment *ev,
											FW_CFrame* frame,
											ODDragItemIterator* dropInfo, 
											ODFacet* odFacet, 
											const FW_CPoint& dropPoint);

	virtual FW_CClipboardCommand* NewClipboardCommand(Environment* ev, ODCommandID commandID);

	// ----- FW_MReceiver overrides ----- 
	virtual void 		HandleNotification(Environment* ev, const FW_CNotification& notification);

//----------------------------------------------------------------------------------------
//	Data Members
//
  private:
	CFormContent* 		fFormContent;

	// subviews
	CRectView*		fScrollerRect;
	CPictView*		fFormPictPict;
	FW_CEditView*     fFirstNameField;
	FW_CEditView*     fLastNameField;
	FW_CEditView*     fMemberNameField;
	FW_CEditView*     fEMailAddressField;
	FW_CEditView*     fCommentsField;
	FW_CButton*     fSubscribeToODFFlashCheck;
	FW_CRadioCluster*	fModemSpeedUsedGroup;
	FW_CListBox*     fPlatformList;
	FW_CButton*     fAddButton;
	FW_CButton*     fRemoveButton;
	FW_CPopupMenu*     fBrowseTimePopup;
	FW_CPopupMenu*     fOtherTimePopup;
	FW_CRadioCluster*	fHowDidYouDiscoverODFWiredGroup;
	FW_CRadioCluster*	fYesNoGroup;
	FW_CButton*     fJoinODFWiredButton;
	FW_CScrollBar*     fHorzScrollBar;
	FW_CScrollBar*     fVertScrollBar;
};

#endif
