//========================================================================================
//
//	File:				Part.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef PART_H
#define PART_H

#ifndef DEFINES_K
#include "Defines.k"
#endif

// ----- Framework Includes -----

#ifndef FWPART_H
#include "FWPart.h"
#endif

// ----- OS Layer -----

#ifndef FWRESFIL_H
#include "FWResFil.h"
#endif

// ----- Foundation Layer -----

#ifndef FWSTDDEF_H
#include "FWStdDef.h"
#endif

#ifndef FWBNDSTR_H
#include "FWBndStr.h"
#endif


//========================================================================================
// Forward Declarations
//========================================================================================

class CFormContent;

//========================================================================================
// CFormPart
//========================================================================================

class CFormPart : public FW_CPart
{
//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
public:

	FW_DECLARE_AUTO(CFormPart)

	CFormPart(ODPart* odPart);
	virtual ~CFormPart();

	virtual void Initialize(Environment* ev);

//----------------------------------------------------------------------------------------
//	Inherited API
//
public:
	virtual FW_CContent*	NewPartContent(Environment* ev);

	virtual FW_CFrame*		NewFrame(Environment* ev,
									ODFrame* odFrame,
									FW_CPresentation* presentation,
									FW_Boolean fromStorage);

	virtual FW_Boolean		DoAdjustMenus(Environment* ev,
									FW_CMenuBar* menuBar, 
									FW_Boolean hasMenuFocus,
									FW_Boolean isRoot);

	virtual FW_Boolean		DoMenu(Environment* ev,
									const FW_CMenuEvent& theMenuEvent);

//----------------------------------------------------------------------------------------
//	New API
//
public:
	void 				DoFormCommand(Environment* ev, ODCommandID id);
		// Handle our two menu commands, cFirstCommand and cSecondCommand

	void				PartChanged(Environment* ev);
		// Call this after changing part data, to notify the proper authorities

//----------------------------------------------------------------------------------------
//	Data Members
//
private:
	CFormContent*			fPartContent;
	FW_CPresentation*	fMainPresentation;
};

#endif
